marmix/urls.py
# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.conf import settings
from django.conf.urls import patterns, include, url
from django.conf.urls.static import static
from django.views.generic import TemplateView

# Uncomment the next two lines to enable the admin:
from django.contrib import admin
admin.autodiscover()
import permission
permission.autodiscover()
from simulations.views import RankingView
from django.contrib.flatpages.sitemaps import FlatPageSitemap
from django.contrib.sitemaps.views import sitemap
from sitemaps import StaticViewSitemap

sitemaps = {
    'flatpages': FlatPageSitemap,
    'static': StaticViewSitemap,
}

urlpatterns = patterns('',
    url(r'^$',  # noqa
        TemplateView.as_view(template_name='pages/home.html'),
        name="home"),
    url(r'^contact/', include('envelope.urls')),
    # Uncomment the next line to enable the admin:
    url(r'^admin/', include(admin.site.urls)),

    # User management
    url(r'^users/', include("users.urls", namespace="users")),
    url(r'^accounts/', include('allauth.urls')),

    # Uncomment the next line to enable avatars
    url(r'^avatar/', include('avatar.urls')),

    # MarMix apps urls
    url(r'^stocks/', include('stocks.urls')),
    url(r'^customers/', include('customers.urls')),
    url(r'^simulations/', include('simulations.urls')),
    url(r'^tickers/', include('tickers.urls')),
    url(r'^ranking/(?P<pk>\d+)/', RankingView.as_view(), name='ranking-view'),
    url(r'^pages/', include('django.contrib.flatpages.urls')),
    url(r'^sitemap\.xml$', sitemap, {'sitemaps': sitemaps},
        name='django.contrib.sitemaps.views.sitemap'),
    url(r'^robots\.txt', include('robots.urls')),

) + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

urlpatterns += patterns('django.contrib.flatpages.views',
    url(r'^about/$', 'flatpage', {'url': '/about/'}, name='about'),
    url(r'^help/$', 'flatpage', {'url': '/help/'}, name='help'),
    url(r'^sitemap/$', 'flatpage', {'url': '/sitemap/'}, name='sitemap'),
    url(r'^start/$', 'flatpage', {'url': '/start/'}, name='start'),
)

from django.conf.urls import url, include
from simulations.views import SimulationViewSet, CurrencyViewSet, TeamViewSet, ClockViewSet
from stocks.views import StockViewSet, QuoteViewSet, OrderViewSet, HoldingsViewSet, CreateOrderViewSet, DividendsViewSet, MarketViewSet, OrderBookViewSet
from users.views import UserViewSet, LoginView, current_user
from tickers.views import CompaniesViewSet
from rest_framework.routers import DefaultRouter


# Create a router and register our viewsets with it.
router = DefaultRouter()
router.register(r'simulations', SimulationViewSet)
router.register(r'currencies', CurrencyViewSet)
router.register(r'users', UserViewSet)
router.register(r'stocks', StockViewSet, base_name='stock')
router.register(r'quotes', QuoteViewSet)
router.register(r'teams', TeamViewSet)
router.register(r'orders', OrderViewSet, base_name='order')
router.register(r'order', CreateOrderViewSet, base_name='create-order')
router.register(r'holdings', HoldingsViewSet, base_name='holdings')
router.register(r'clock', ClockViewSet, base_name='clock')
router.register(r'tickers', CompaniesViewSet, base_name='ticker')
router.register(r'dividends', DividendsViewSet, base_name='dividend')
router.register(r'market', MarketViewSet, base_name='market')
router.register(r'book', OrderBookViewSet, base_name='book')

# The API URLs are now determined automatically by the router.
# Additionally, we include the login URLs for the browsable API.
urlpatterns += [
    url(r'^api/v1/', include(router.urls)),
    url(r'^api-auth/', include('rest_framework.urls', namespace='rest_framework')),
    url(r'^api/v1/auth/login/$', LoginView.as_view(), name='login'),
    url(r'^api/v1/current-user/$', current_user, name='current_user'),
]

marmix/users/urls.py
# -*- coding: utf-8 -*-
from django.conf.urls import patterns, url

from users import views
from simulations.views import TeamJoinView

urlpatterns = patterns('',
    # URL pattern for the UserListView  # noqa
    url(
        regex=r'^$',
        view=views.UserListView.as_view(),
        name='list'
    ),
    # URL pattern for the UserRedirectView
    url(
        regex=r'^~redirect/$',
        view=views.UserRedirectView.as_view(),
        name='redirect'
    ),
    # URL pattern for the UserDetailView
    url(
        regex=r'^(?P<username>[\w.@+-]+)/$',
        view=views.UserDetailView.as_view(),
        name='detail'
    ),
    # URL pattern for the UserUpdateView
    url(
        regex=r'^~update/$',
        view=views.UserUpdateView.as_view(),
        name='update'
    ),
)

marmix/users/models.py
# -*- coding: utf-8 -*-
# Import the AbstractUser model
from django.contrib.auth.models import AbstractUser
from django.db import models
from jsonfield import JSONField


#from simulations.models import Simulation


class User(AbstractUser):

    dashboard = JSONField(null=True, blank=True)
    #ame = models.CharField(verbose_name="name", max_length=50)

    def _is_poweruser(self):
        if self.organizations.all().count() > 0 or self.is_staff:
        #if self.is_staff:
            return True
        return False
    is_poweruser = property(_is_poweruser)

    def _get_team(self):
        from simulations.models import Simulation, Team
        return Team.objects.filter(simulations__state__gte=Simulation.READY, simulations__state__lte=Simulation.FINISHED).filter(users__username=self.username).first()
    get_team = property(_get_team)

    def __unicode__(self):
        return self.username

marmix/users/forms.py
# -*- coding: utf-8 -*-
from django import forms

from .models import User


class UserForm(forms.ModelForm):

    class Meta:
        # Set this form to use the User model.
        model = User

        # Constrain the UserForm to just these fields.
        fields = ("first_name", "last_name")

marmix/users/views.py
# -*- coding: utf-8 -*-
# Import the reverse lookup function
from django.core.urlresolvers import reverse

# view imports
from django.views.generic import DetailView
from django.views.generic import RedirectView
from django.views.generic import UpdateView
from django.views.generic import ListView
from rest_framework import viewsets, permissions
from rest_framework.decorators import api_view

# Only authenticated users can access views using this.
from braces.views import LoginRequiredMixin

# Import the form from users/forms.py
from .forms import UserForm

# Import the customized User model
from .models import User
from .serializers import UserSerializer, AccountSerializer


class UserDetailView(LoginRequiredMixin, DetailView):
    model = User
    # These next two lines tell the view to index lookups by username
    slug_field = "username"
    slug_url_kwarg = "username"


class UserRedirectView(LoginRequiredMixin, RedirectView):
    permanent = False

    def get_redirect_url(self):
        return reverse("users:detail",
                       kwargs={"username": self.request.user.username})


class UserUpdateView(LoginRequiredMixin, UpdateView):

    form_class = UserForm

    # we already imported User in the view code above, remember?
    model = User

    # send the user back to their own page after a successful update
    def get_success_url(self):
        return reverse("users:detail",
                       kwargs={"username": self.request.user.username})

    def get_object(self):
        # Only get the User record for the user making the request
        return User.objects.get(username=self.request.user.username)


class UserListView(LoginRequiredMixin, ListView):
    model = User
    # These next two lines tell the view to index lookups by username
    slug_field = "username"
    slug_url_kwarg = "username"


class UserViewSet(viewsets.ModelViewSet):
    """
    This viewset automatically provides `list` and `detail` actions.
    """
    queryset = User.objects.all()
    serializer_class = UserSerializer
    permission_classes = (permissions.IsAuthenticatedOrReadOnly,)
    http_method_names = ('get', 'put')


@api_view(['GET'])
def current_user(request):
    user = request.user
    return Response({
        'username': user.username,
        'id': user.id,
        'dashboard': user.dashboard
    })


import json

from django.contrib.auth import authenticate, login

from rest_framework import status, views
from rest_framework.response import Response


class LoginView(views.APIView):

    def post(self, request, format=None):
        data = json.loads(request.body.decode('utf-8'))

        username = data.get('username', None)
        password = data.get('password', None)

        account = authenticate(username=username, password=password)

        if account is not None:
            if account.is_active:
                login(request, account)

                serialized = AccountSerializer(account)

                return Response(serialized.data)
            else:
                return Response({
                    'status': 'Unauthorized',
                    'message': 'This account has been disabled.'
                }, status=status.HTTP_401_UNAUTHORIZED)
        else:
            return Response({
                'status': 'Unauthorized',
                'message': 'Username/password combination invalid.'
            }, status=status.HTTP_401_UNAUTHORIZED)

marmix/templates/users/user_detail.html
{% extends "base.html" %}
{% load static %}
{% load avatar_tags %}

{% block title %}
    {{ object.username|capfirst }}'s Dashboard
{% endblock title %}

{% block content %}
<section class="page-top">
    <div class="container">
        <div class="row">
            <div class="col-md-12">
                <ul class="breadcrumb">
                    <li><a href="{% url 'home' %}">Home</a></li>
                    <li class="active">Dashboard</li>
                </ul>
            </div>
        </div>
        <div class="row">
            <div class="col-md-12">
                <h1>{{ object.username|capfirst }}'s Dashboard</h1>
            </div>
        </div>
    </div>
</section>
<div class="container">
    <div class="row">
        <div class="col-sm-8">
            <h2>{{ object.username|capfirst }}</h2>
            <div class="row">
                <div class="col-sm-2">
                    {% if object == request.user %}<a href="{% url 'avatar_change' %}">{% avatar object %}</a>{% else %}{% avatar object %}{% endif %}
                </div>
                <div class="col-sm-6">
                    <dl class="">
                        <dt>Name</dt>
                        <dd>{{ object.first_name }} {{ object.last_name }} {% if object == request.user %}<a class="btn btn-primary btn-xs" href="{% url 'users:update' %}"><i class="fa fa-pencil-square-o"></i> Edit</a>{% endif %}</dd>
                        <dt>Email</dt>
                        <dd>{{ object.email }} {% if object == request.user %}<a class="btn btn-primary btn-xs" href="{% url 'account_email' %}">{% if object.email %}<i class="fa fa-pencil-square-o"></i> Edit{% else %}<i class="fa fa-plus-square-o fa-lg"></i> Add{% endif %}</a>{% endif %}</dd>
                    </dl>
                </div>
            </div>
            <dl class="">
                <dt>Date joined</dt>
                <dd>{{ object.date_joined|date:"SHORT_DATE_FORMAT" }}</dd>
                <dt>Last login</dt>
                <dd>{{ object.last_login|date:"SHORT_DATE_FORMAT" }}</dd>
                <dt>Permissions</dt>
                <dd>Active {% if object.is_active %}<i class="fa fa-check"></i>{% else %}<i class="fa fa-times"></i>{% endif %} |
                    Manager {% if object.is_poweruser %}<i class="fa fa-check"></i>{% else %}<i class="fa fa-times"></i>{% endif %} |
                    Staff {% if object.is_staff %}<i class="fa fa-check"></i>{% else %}<i class="fa fa-times"></i>{% endif %} |
                    Superuser {% if object.is_superuser %}<i class="fa fa-check"></i>{% else %}<i class="fa fa-times"></i>{% endif %}
                </dd>
            </dl>
            {% if object.get_team.current_simulation.info %}
            <div class="panel panel-default">
                <div class="panel-heading">
                    <h4 class="panel-title"><i class="fa fa-comments-o"></i> Infobox</h4>
                </div>
                <div class="panel-body">
                    {{ object.get_team.current_simulation.info|safe }}
                </div>
            </div>
            {% endif %}
        </div>
        <div class="col-sm-4">
            <div class="panel panel-primary">
                <div class="panel-heading">
                    {% if object == request.user %}
                    <div class="btn-group pull-right">
                        <a class="btn btn-warning btn-xs" href="{% url 'team-join-view' %}"><i class="fa fa-plus-square"></i> Join a team</a>
                    </div>
                    {% endif %}
                    <h3 class="panel-title"><i class="fa fa-users"></i> Team</h3>
                </div>
                <div class="panel-body">
                    {% if object.teams.all %}
                    <ul class="list-group">
                        {% for team in object.teams.all %}
                        <li class="list-group-item"><a href="{% url 'team-detail-view' team.id  %}">{{ team.name }}</a></li>
                        {% endfor %}
                    </ul>
                    {% else %}
                        <p>Currently not member of any team.</p>
                    {% endif %}
                </div>
            </div>
            <div class="panel panel-primary">
                <div class="panel-heading">
                    <h3 class="panel-title"><i class="fa fa-wrench"></i> Market tools</h3>
                </div>
                <div class="panel-body">
                    <p><a class="btn btn-info btn-block" href="https://m3.marmix.ch/static/dashboard/#/" target="_blank"><i class="fa fa-line-chart"></i> Trading dashboard</a></p>
                    <p><a class="btn btn-info btn-block" href="https://m3.marmix.ch/static/dashboard/#/ticker" target="_blank"><i class="fa fa-money"></i> Companies financials</a></p>
                {% if request.user.get_team.current_simulation_id %}
                    <p><a class="btn btn-info btn-block" href="{% url "ranking-view" request.user.get_team.current_simulation_id %}" target="_blank"><i class="fa fa-list-ol"></i> Current ranking</a></p>
                {% endif %}
                </div>
            </div>
        </div>
    </div>
    <hr>
    <div class="row">
        <div class="col-sm-12 ">
            <h2>Past simulations</h2>
            <table class="table table-striped">
                <thead>
                    <tr>
                        <th>Simulation</th>
                        <th>Date</th>
                        <th>Ranking</th>
                        <th>Data</th>
                    </tr>
                </thead>
                <tbody>
                {% for simulation in object.get_team.simulations.all %}
                    <tr>
                        <td>
                            {{ simulation.code }}
                        </td>
                        <td>
                            {{ simulation.created }}
                        </td>
                        <td>
                            <a class="btn btn-info btn-xs" href="{% url "ranking-view" simulation.id %}" target="_blank"><i class="fa fa-list-ol"></i> View ranking</a>
                        </td>
                        <td>
                            <a class="btn btn-info btn-xs" href="{% url "company-shares-export-xlsx-simulation" simulation.id %}"><i class="fa fa-file-excel-o"></i> Download data</a>
                        </td>
                {% empty %}
                    <p>No simulation yet!</p>
                {% endfor %}
                </tbody>
            </table>
        </div>
    </div>
</div>
{% endblock content %}

marmix/templates/users/user_form.html
{% extends "base.html" %}
{% load crispy_forms_tags %}

{% block title %}User: {{ user.username }}{% endblock %}

{% block content %}

<div class="container">
    <div class="row">
        <div class="col-lg-12">
            <h1>{% block header %}User: {{ user.username }}{% endblock %}</h1>
            <form class="form-horizontal" method="post" action="{% url 'users:update' %}">
                {% csrf_token %}
                {{ form|crispy }}
                <div class="control-group">
                  <div class="controls">
                    <button type="submit" class="btn">Update</button>
                  </div>
                </div>
            </form>
        </div>
    </div>
</div>
{% endblock %}

marmix/templates/users/user_list.html
{% extends "base.html" %}
{% load static %}{% load i18n %}
{% load avatar_tags %}

{% block title %}Members{% endblock %}

{% block content %}

<div class="container">
    
  <div class="row">
    <div class="col-xs-12">
      <h2>Users</h2>
    </div>
  </div>

  <div class="row">
    <div class="col-lg-12">
      <div class="list-group">
          {% for user in user_list %}
            <a href="{% url 'users:detail' user.username %}" class="list-group-item">
              <h4 class="list-group-item-heading">{% avatar user %} {{ user.username }}</h4>
              <p class="list-group-item-text">{{ maker.tagline }}</p>
            </a>
          {% endfor %}
        
      </div>
    </div>
  </div>

</div>

{% endblock content %}